[sdata, fs, nb] = wavread('Data\Tony\ton2_2.wav'); 

% params
window = hann(1024);
overlap = 0.5;
log = 'log';
doplot = true;

spec = spectrogramm(sdata, fs, window, overlap, log, doplot);

% filter and dominant
cutfreq = 80;
fftsize = 1024;

specf = abs(spec); dominant = []; dominantg = []; dominantg2 = []; AAAg = [];

for i = 1:size(spec, 2)
    % get window
    window = specf(:, i);
    
    % filter one window
    indexcut = 1 + floor(cutfreq * fftsize / fs);
    for j = indexcut:-1:1
        if j == indexcut
            f1 = fs / fftsize;
            fj = fs * j / fftsize;
            window(j) = window(j) * (fj - cutfreq) / f1;
        else
            window(j) = 0;
        end
    end
    specf(:, i) = window;

%      xx = floor(512 / 120); w = zeros(1, 12); iter = 1;
%      for i = 1:12
%          w(i) = sum(window(iter:iter + xx - 1, 1));
%          iter = iter + xx;        
%      end
%      
%      find(w == max(w))
    
    % dominant freq
    windowsize = 4;
    maxweight = -1.0;
    centerfreq = -1.0;
    maxx = bitshift(fftsize, -1);
    startsave = -1;
    AAA = -1;
    for k = windowsize:maxx
        start = k - windowsize;

        moment = 0.0;
        weight = 0.0;

        for j = start:k
            weight = weight + window(j + 1);
            moment = moment + j * window(j + 1);
        end

        if weight > maxweight
            AAA = start;
            maxweight = weight;
            centerfreq = moment / weight;
        end
    end    

    AAAg = [AAAg AAA];
    
    lastfreq = 0.0;
	freq = fs * centerfreq / fftsize;
	freq = (lastfreq + freq) / 2.0;
		
	% convert frequency into something understandable
	logfactor = log10(1.0594630915);
	dnote = log10(freq / 27.500003562436501) / logfactor;
	note = floor(dnote + 0.5);
    which = mod(note, 12);
	switch which
		case 0
            domfreq = 0;
		case 1 
            domfreq = 1; 
		case 2 
            domfreq = 2; 
		case 3 
            domfreq = 3;
		case 4 
            domfreq = 4;
		case 5 
            domfreq = 5;
		case 6 
            domfreq = 6;
		case 7 
            domfreq = 7;
		case 8 
            domfreq = 8;
		case 9 
            domfreq = 9;
		case 10 
            domfreq = 10;
		case 11 
            domfreq = 11;
    end
	domfreqpercent = 100 * (dnote - note);
    
    d.domfreq = domfreq;
    d.domfreqpercent = domfreqpercent;
    dominant = [dominant d];
    
    if (abs(domfreqpercent) < 3.0)
        dominantg = [dominantg domfreq];
        dominantg2 = [dominantg2 domfreqpercent];

%         i
%         domfreq
%         domfreqpercent
    end
end

figure;
plot(dominantg);
figure;
plot(dominantg2);

figure;
plot(1:length(AAAg), AAAg, 'x');





