function output = dftrans(sdata, npoint)
% dftrans vypocita diskretnu fourierovu transformaciu
%
% sdata - navzorkovane data
% npoint - n-bodova fourierova transformacia

% inicializacia
if nargin == 1
    npoint = size(sdata, 2);
else
    sdatasize = size(sdatasize, 2);
    npointsize = size(npoint, 2);
    
    if npointsize > sdatasize
        % doplnenie nulami
        sdata = [sdata zeros(1, npointsize - sdatasize)];
    elseif npointsize < sdatasize
        % orezanie
        sdata = sdata(1, 1:npointsize);
    end
end

output = p_dftrans(sdata, npoint);

%========================================
function output = p_dftrans(sdata, npoint)
% vypocet diskretnej fourierovej transformacie

w = exp(2 * pi * i / npoint); 
output = [];
for n = 0:npoint - 1
    h = 0;  
    for k = 0:npoint - 1
        wnk = w ^ (n * k);
        h = h + wnk * sdata(k + 1);
    end
    output = [output h];    
end

