function [Ymean] = meanspectrogram(sdata, fs, windowsize, overlap, log, doplot)

sdatalen = length(sdata);                     
w = hann(windowsize);
Ymean = zeros(windowsize, 1);

pos = 1;
cnt = 0;
nhop = windowsize - round(windowsize * overlap);
while ((pos + windowsize) < sdatalen)
    y = sdata(pos:(pos + windowsize-1)) .* w;       
    
    Y = fft(y, windowsize);                
    
    Ymean = Ymean + abs(Y);
    
    cnt = cnt + 1;
    pos = pos + nhop;
end

disp('Found windows'); disp(cnt);

if (cnt > 0)
    if log == 'log'
        Ymean = 20 * log10(Ymean / cnt + eps);
    elseif log == 'not'
        Ymean = Ymean / cnt;
    end
    
    if doplot
        f = (0:windowsize-1) * fs / windowsize;
        plot(f, Ymean);
    end
end




