function pcp = pcpfeatures(spec, count, fs, doplot)

pcp = zeros(count, size(spec, 2));
for i = 1:size(spec, 2)
    pcp(:, i) = pcpfeatures_(spec(:, i), count, fs);
    %pcp(8, i) = 0; %!
end

if doplot
    figure;
    t = (0:size(spec,2)-1) * 512 / fs;
    f = 1:count;
    imagesc(t, f, pcp);
    axis('xy');
    colormap(gray);
    xlabel('Time (sec)');
    ylabel('PCP');
end

% =====================================
function pcp = pcpfeatures_(window, count, fs)

N = length(window);

k = 1:N;
const = fs / (N * 440);
pk_pom = floor(count * log2(const * k));
pk = mod(pk_pom, count);

pcp = zeros(count, 1);
for p = 1:count
    indexes = find(pk == (p - 1));
    
    for k = 1:length(indexes)
        index = indexes(k);
        %pcp(p) = pcp(p) + abs(window(index)); % ^ 2; %20 * log10(abs(window(index)) + eps); %abs(window(index)) ^ 2;
        pcp(p) = pcp(p) + window(index); 
    end
end
