function specout = spectrogramm(sdata, fs, window, overlap, log, doplot)

sdatalen = length(sdata);                     
windowsize = length(window);

noverlap = round(windowsize * overlap);
nhop = windowsize - noverlap;

sdatalen = length(sdata);
windowsc = 1 + floor((sdatalen - noverlap) / nhop) - 1;

specout = zeros(windowsize, windowsc);

pos = 1;
for i = 1:windowsc 
    y = sdata(pos:pos + windowsize - 1) .* window;       
    
    f = fft(y, windowsize);                
    
    specout(:, i) = f;
    
    pos = pos + nhop;
end

spec = specout(1:windowsize/2+1, :);

if (windowsc > 0)
    %spec = specout;
    
    if log == 'log'
        spec = 20 * log10(abs(spec) + eps);
    elseif log == 'not'
        spec = abs(spec);
    end
    
    Xdb = spec;
    
    if doplot
      figure;
      t = (0:windowsc-1)*nhop/fs;
      f = 0.001*(0:windowsize/2)*fs/windowsize;
      %!Xdb = 20*log10(abs(spec));
      %Xmax = max(max(Xdb));
      % Clip lower limit so nulls don't dominate:
      %clipvals = [Xmax-100,Xmax];
      imagesc(t,f,Xdb);%,clipvals);
      % grid;
      axis('xy');
      colormap(jet);
      xlabel('Time (sec)');
      ylabel('Freq (kHz)');
    end
end

